﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Remotion.Mixins;
using System.Web.Mvc;

namespace RemixMvcApplication
{
    public class EchoControllerMixin : Mixin<ControllerBase>, IEchoControllerMixin
    {
        public ActionResult Echo(string id)
        {
            var result = new ContentResult();
            var controllerName = Target.ControllerContext.RouteData.Values["controller"].ToString();
            result.Content = string.Format("re-mix added Echo action to controller '{0}'<hr/>You said: {1}", controllerName, !string.IsNullOrEmpty(id) ? id : "<i>nothing</i>");
            return result;
        }

        [OverrideTarget]
        protected IActionInvoker CreateActionInvoker()
        {
            return new RemixControllerActionInvoker(typeof(IEchoControllerMixin));
        }

    }
}