﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Reflection;

namespace RemixMvcApplication
{
    public class RemixControllerActionInvoker : ControllerActionInvoker
    {
        private Type _remixType;

        public RemixControllerActionInvoker(Type remixType)
        {
            _remixType = remixType;
        }

        protected override ActionDescriptor FindAction(ControllerContext controllerContext, ControllerDescriptor controllerDescriptor, string actionName)
        {
            // Use default action descriptor
            ActionDescriptor actionDescriptor = controllerDescriptor.FindAction(controllerContext, actionName);
            if (actionDescriptor != null) return actionDescriptor;

            // Create action descriptor that accepts actions that are defined in the remix type
            var internalConstructor = typeof(ReflectedActionDescriptor).GetConstructor(
                BindingFlags.NonPublic | BindingFlags.Instance, null, new [] { typeof(MethodInfo), typeof(string), typeof(ControllerDescriptor), typeof(bool) }, null
            );
            return (ActionDescriptor)internalConstructor.Invoke(new object[] { _remixType.GetMethod(actionName), actionName, controllerDescriptor, false });
        }
    }
}