﻿using System;using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using Remotion.Mixins;
using System.Web.SessionState;

namespace RemixMvcApplication
{
    public class RemixControllerFactory : IControllerFactory
    {
        private IControllerFactory _defaultControllerFactory;

        public RemixControllerFactory()
        {
            _defaultControllerFactory = new DefaultControllerFactory();
        }

        public IController CreateController(RequestContext requestContext, string controllerName)
        {
            // Use the default ControllerFactory to get the type of the controller
            var controller = _defaultControllerFactory.CreateController(requestContext, controllerName);

            // Use remix's ObjectFactory to instantiate the (mixed) controller
            return (IController)ObjectFactory.Create(controller.GetType());
        }

        public SessionStateBehavior GetControllerSessionBehavior(RequestContext requestContext, string controllerName)
        {
            return SessionStateBehavior.Default;
        }

        public void ReleaseController(IController controller)
        {
        }
    }
}